<template lang="pug">
.col.q-pa-md
  .text-h6.q-mb-sm {{ context.room }}
  .row
    q-btn.q-mb-md(
      color="primary",
      :icon="showMessages ? 'visibility' : 'visibility_off'",
      :label="`${showMessages ? 'hide' : 'show'} messages`",
      @click="showMessages = !showMessages"
    )
    Messages(
      v-if="showMessages",
      :messages="messagesForBreakoutRoom",
      :sectionStartTime="0",
      :sectionDuration="0",
      :zoomSensors="[]"
    )
</template>
<script>
import humanInterval from "human-interval";
import Messages from "./Messages.vue";

export default {
  props: {
    context: { required: true },
    firebase: { required: true },
    functions: { required: true },
  },
  data() {
    return {
      currentState: { loading: true },
      currentSection: { loading: true },
      advance: { loading: true },
      showMessages: false,
    };
  },
  computed: {
    messagesForBreakoutRoom() {
      return ((this.config || {}).messages || []).filter(
        (m) =>
          m.config &&
          m.config.type === "sensor" &&
          m.config.sensor === this.context.room
      );
    },
    config() {
      return (this.currentState.plugins || {}).task || {};
    },
    sectionStartTime() {
      return this.currentState.startedAt;
    },
    sectionDuration() {
      return humanInterval(this.advance.when);
    },
  },
  methods: {
    async handleSendMessage(messageIndex) {
      const sendMessage = this.functions.httpsCallable("Task-sendMessage");
      await sendMessage({ messageIndex, meetingId: this.context.meetingid });
    },
  },
  watch: {
    firebase: {
      immediate: true,
      async handler() {
        if (!this.context.meetingid) return;

        await this.$rtdbBind(
          "currentState",
          this.firebase.ref(
            `/config/${this.context.meetingid}/current/currentState/`
          )
        );

        await this.$rtdbBind(
          "currentSection",
          this.firebase.ref(
            `/config/${this.context.meetingid}/current/currentSection`
          )
        );
      },
    },
    currentSection: {
      immediate: true,
      async handler(value) {
        await this.$rtdbBind(
          "advance",
          this.firebase.ref(
            `/config/${this.context.meetingid}/schedule/schedule/script/${value[".value"]}/advance/`
          )
        );
      },
    },
  },
  components: {
    Messages,
  },
};
</script>
